Attribute VB_Name = "modIAEVCallback"
Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0
Private Const E_NOINTERFACE As Long = &H80004002
Private Const IID_IAudioEndpointVolumeCallback As String = "{657804FA-D6AD-4496-8A60-352752AF4F89}"

' ----==== Types ====----
Private Type tIAudioEndpointVolumeCallback
    pVTable As Long
End Type

Private Type tIAudioEndpointVolumeCallbackVTable
    VTable(0 To 3) As Long
End Type

' ----==== Variablen ====----
Private m_IPtr As Long
Private m_RefCount As Long
Private m_Interface As Object
Private m_IAudioEndpointVolumeCallback As tIAudioEndpointVolumeCallback
Private m_IAudioEndpointVolumeCallbackVTable As tIAudioEndpointVolumeCallbackVTable

Public Function IAudioEndpointVolumeCallback(ByVal cIAudioEndpointVolumeCallback As Long) As Long

    ' Objekt vom Pointer
    Call CopyMemory(m_Interface, cIAudioEndpointVolumeCallback, 4)

    ' ----==== Interface IAudioEndpointVolumeCallback  ====----
    With m_IAudioEndpointVolumeCallbackVTable
        
        ' VTable aufbauen
        .VTable(0) = ProcPtr(AddressOf QueryInterface)
        .VTable(1) = ProcPtr(AddressOf AddRef)
        .VTable(2) = ProcPtr(AddressOf Release)
        .VTable(3) = ProcPtr(AddressOf OnNotify)

    End With

    With m_IAudioEndpointVolumeCallback

        ' Pointer auf die VTable
        .pVTable = VarPtr(m_IAudioEndpointVolumeCallbackVTable)

    End With

    ' Pointer auf das Interface
    m_IPtr = VarPtr(m_IAudioEndpointVolumeCallback)

    IAudioEndpointVolumeCallback = m_IPtr

End Function

Private Function ProcPtr(ByVal ptr As Long) As Long

    ProcPtr = ptr

End Function

' ----==== Interface IUnknown Func ====----
Private Function QueryInterface(ByVal this As Long, ByRef riid As GUID, ByRef _
    pvObj As Long) As Long

    Dim lRet As Long
    
    Select Case UCase$(Guid2Str(riid))
    
    ' wenn nach dem Interface IAudioEndpointVolumeCallback gefragt wird
    Case UCase$(IID_IAudioEndpointVolumeCallback)

        ' dann muss ein AddRef aufgerufen werden.
        Call AddRef(this)
        
        ' Pointer auf das Interface
        pvObj = VarPtr(m_IAudioEndpointVolumeCallback)
        
        ' OK zurck geben, Interface ist vorhanden
        lRet = S_OK

    Case Else
        
        ' alles andere ignorieren
        
        pvObj = 0&
        
        lRet = E_NOINTERFACE
    
    End Select

    QueryInterface = lRet

End Function

Private Function AddRef(ByVal this As Long) As Long

    m_RefCount = m_RefCount + 1

    AddRef = m_RefCount
    
End Function

Private Function Release(ByVal this As Long) As Long
    
    m_RefCount = m_RefCount - 1
    
    If m_RefCount = 0 Then
    
        ' alles Aufrumen und Freigeben
        m_IAudioEndpointVolumeCallback.pVTable = 0&
        Erase m_IAudioEndpointVolumeCallbackVTable.VTable
        
        m_IPtr = 0&
        
        ' Objekt lschen
        Call CopyMemory(m_Interface, 0&, 4)
        
    End If
    
    Release = m_RefCount

End Function

' ----==== Interface IAudioEndpointVolumeCallback Func ====----
'
Private Function OnNotify(ByVal this As Long, ByVal pNotify As Long) As Long

    ' Funktion in der Klasse aufrufen
    Call m_Interface.OnNotify(pNotify)

End Function

