Attribute VB_Name = "modInterface"
Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const CLSCTX_INPROC As Long = &H1&
Private Const CC_STDCALL As Long = &H4&
Private Const IID_Release As Long = &H8&

' ----==== Type ====----
Public Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

' ----==== OleAut32 API-Deklarationen ====----
Private Declare Function DispCallFunc Lib "OleAut32.dll" ( _
                    ByVal pvInstance As Long, _
                    ByVal oVft As Long, _
                    ByVal cc As Long, _
                    ByVal vtReturn As VbVarType, _
                    ByVal cActuals As Long, _
                    ByVal prgvt As Any, _
                    ByVal prgpvarg As Any, _
                    ByRef pvargResult As Variant) As Long

' ----==== Ole32 API-Deklarationen ====----
Public Declare Sub CoTaskMemFree Lib "ole32.dll" ( _
                   ByVal hMem As Long)

Private Declare Function CLSIDFromString Lib "ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long
                         
Private Declare Function StringFromGUID Lib "ole32.dll" _
                         Alias "StringFromGUID2" ( _
                         ByRef rguid As GUID, _
                         ByVal lpsz As Long, _
                         ByVal cchMax As Long) As Long

Private Declare Function CoCreateInstance Lib "ole32.dll" ( _
                         ByVal rclsid As Long, _
                         ByVal pUnkOuter As Long, _
                         ByVal dwClsContext As Long, _
                         ByVal riid As Long, _
                         ByRef ppv As Long) As Long

' ----==== Kernel32.dll API-Deklarationen ====----
Public Declare Sub CopyMemory Lib "Kernel32.dll" _
                   Alias "RtlMoveMemory" ( _
                   ByRef Destination As Any, _
                   ByRef Source As Any, _
                   ByVal length As Long)

' ----==== Init Interface ====----
Public Function InitInterface(ByRef pInterface As Long, ByVal sCLSID As String, _
    ByVal sIID As String) As Boolean

    Dim bRet As Boolean
    Dim tIID As GUID
    Dim tCLSID As GUID
    Dim psIID As Long
    Dim psCLSID As Long
    Dim ptIID As Long
    Dim ptCLSID As Long

    bRet = False
    
    psCLSID = StrPtr(sCLSID)

    ' CLSID -> GUID
    If CLSIDFromString(psCLSID, tCLSID) = S_OK Then

        ptCLSID = VarPtr(tCLSID)

        psIID = StrPtr(sIID)

        ' IID -> GUID
        If CLSIDFromString(psIID, tIID) = S_OK Then

            ptIID = VarPtr(tIID)

            ' Interface erstellen
            If CoCreateInstance(ptCLSID, 0&, CLSCTX_INPROC, ptIID, pInterface) = S_OK Then

                bRet = True

            End If

        End If

    End If

    InitInterface = bRet

End Function

' ----==== Release Interface ====----
Public Sub ReleaseInterface(ByRef pInterface As Long)

    Dim vRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, vRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== Call Interface Function ====----
Public Function OleInvoke(ByVal pInterface As Long, ByVal lCmd As Long, _
    ParamArray aParam()) As Variant
    
    Dim lCount As Long
    Dim lItem As Long
    Dim vRet As Variant
    Dim vParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer
    Dim polePtr As Long
    Dim poleTyp As Long

    ' wenn ein Pointer auf ein Interface vorhanden ist
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            vParam = aParam

            ' ist der Variant ein Array
            If IsArray(vParam) Then vParam = vParam(0)

            ' Anzahl der Parameter
            lCount = UBound(vParam)

            ' alle Parameter durchlaufen
            For lItem = 0 To lCount

                ' Typ des Parameter
                oleTyp(lItem) = VarType(vParam(lItem))

                ' Pointer auf den Parameter
                olePtr(lItem) = VarPtr(vParam(lItem))

            Next

        End If

        ' Pointer holen
        poleTyp = VarPtr(oleTyp(0))
        polePtr = VarPtr(olePtr(0))

        ' Funktion des Interfaces aufrufen
        If DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vbLong, _
            lItem, poleTyp, polePtr, vRet) <> S_OK Then
            
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"

        End If

    End If

    OleInvoke = vRet

End Function

' ----==== Helper Function ====----
Public Function Str2Guid(ByVal str As String) As GUID

    Dim pstr As Long
    
    pstr = StrPtr(str)
    
    Call CLSIDFromString(pstr, Str2Guid)
    
End Function

Public Function Guid2Str(ByRef tGUID As GUID) As String

    Dim lRet As Long
    Dim sGUID As String

    sGUID = String(40, 0)

    lRet = StringFromGUID(tGUID, StrPtr(sGUID), Len(sGUID))

    If lRet > 0 Then

        sGUID = Left$(sGUID, lRet - 1)

    Else

        sGUID = vbNullString

    End If

    Guid2Str = sGUID

End Function

